<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 06/28/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-optimize.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Database optimization functions                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Datenbank-Optimierungsfunktionen                 *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.0.6";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_optimize_gain(
  id BIGINT(20) NOT NULL AUTO_INCREMENT,
  gain decimal(10,3) NOT NULL DEFAULT '0.000',
  PRIMARY KEY(id)
) TYPE=MyISAM";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('misc', 'optimize', 'DB optimieren', 'F&uuml;hren Sie dies ab und an aus, damit &uuml;berfl&uuml;ssige Daten aus der Datenbank entfernt werden.', '5')";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_optimize_gain";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE what='optimize' LIMIT 1";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.0.2": // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.0.3": // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Erweiterung bleibt wegen integrierten Schalters immer aktiv.";
		break;

	case "0.0.4": // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"".SERVER_URL."/patches/340-Gast_Mitgliedsmenue_Deaktivieren.zip\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.0.5": // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.0.6": // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "HTML-Code ausgelagert in Templates.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	break;
}

// Language file prefix
$EXT_LANG_PREFIX = "optimize";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "Y";

//
?>
