<?php
/************************************************************************
 * M-XChange v0.2.1                                   Start: 04/24/2005 *
 * ================                             Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-lock_sponsor.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Edit sponsor account                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenaccount aendern                         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software. You can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License.       *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!is_admin())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));
$MSG = "";

if (!empty($_GET['id'])) {
	// Check for selected sponsor
	$result = SQL_QUERY_ESC("SELECT salut, surname, family, email, status FROM "._MYSQL_PREFIX."_sponsor_data WHERE id='%s' LIMIT 1",
	 array(bigintval($_GET['id'])), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Get sponsor's current status and let only confirmed and locked status pass
		list($salut, $sname, $fname, $email, $status) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		if (($status == "CONFIRMED") || ($status == "LOCKED")) {
			// Transfer data to constants
			define('__SALUT'  , TRANSLATE_SEX($salut));
			define('__SURNAME', $sname);
			define('__FAMILY' , $fname);
			define('__ID'     , bigintval($_GET['id']));

			if (isset($_POST['ok'])) {
				// Create messages
				if ($status == "CONFIRMED") {
					// Message when sponsor's account got lock
					define('__EMAIL_MSG', SPONSOR_ACCOUNT_LOCKED);
					$subject = SPONSOR_SUBJECT_LOCKED;
					$status = "LOCKED";
				} else {
					// Message when sponsor's account got unlock
					define('__EMAIL_MSG', SPONSOR_ACCOUNT_UNLOCKED);
					$subject = SPONSOR_SUBJECT_UNLOCKED;
					$status = "CONFIRMED";
				}

				// Load email message
				$msg = LOAD_EMAIL_TEMPLATE("lock_sponsor", $_POST['reason'], bigintval($_GET['id']));

				// And send it away
				SEND_EMAIL($email, $subject, $msg);

				// Update sponsor's account
				$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_sponsor_data SET status='".$status."' WHERE id='%s' LIMIT 1",
				 array(bigintval($_GET['id'])), __FILE__, __LINE__);
			} elseif (!empty($_POST['no'])) {
				// No don't lock / unlock now!
				LOAD_URL(URL."/modules.php?module=admin&what=list_sponsor&id=".bigintval($_GET['id']));
			} else {
				// Create header and text messages
				if ($status == "CONFIRMED") {
					// Messages when sponsor's account is confirmed
					define('__HEADER_MESSAGE', SPONSOR_LOCK_SPONSOR_HEADER);
					define('__TEXT_MESSAGE'  , SPONSOR_LOCK_SPONSOR_TEXT);
				} else {
					// Messages when sponsor's account is locked
					define('__HEADER_MESSAGE', SPONSOR_UNLOCK_SPONSOR_HEADER);
					define('__TEXT_MESSAGE'  , SPONSOR_UNLOCK_SPONSOR_TEXT);
				}

				// Create email link
				define('__EMAIL_LINK', "<A href=\"mailto:".$email."\">".__SALUT." ".__SURNAME." ".__FAMILY."</A>");

				// Display form
				LOAD_TEMPLATE("admin_lock_sponsor");
			}
		} else {
			// Cannot change status on unconfirmed or pending accounts!
			$MSG = ADMIN_SPONSPOR_CANNOT_LOCK_PENDING_UNCINFIRMED_ACCOUNTS;
		}
	} else {
		// Sponsor not found!
		$MSG = ADMIN_SPONSOR_404_1.bigintval($_GET['id']).ADMIN_SPONSOR_404_2;
	}
} else {
	// Not called by what-list_sponsor.php
	$MSG = ADMIN_CALL_NOT_DIRECTLY;
}

if (!empty($MSG)) {
	// Output message
	LOAD_TEMPLATE("admin_settings_saved", false, $MSG);
}
//
?>
